<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 11/22/2005 *
 * ===================                          Last change: 11/22/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : bonus_mails.php                                  *
 * -------------------------------------------------------------------- *
 * Short description : Sends out reminder mails                         *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Versendet Erinnerungsmails                       *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2011 by Mailer Developer Team                   *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} elseif ((!isExtensionActive('bonus')) || (isExtensionInstalledAndOlder('bonus', '0.9.2'))) {
	return;
}

// Do not execute when script is in CSS mode
if (!isHtmlOutputMode()) return;

// Create timemark from saved month
$mark = mktime(0, 0, 0, getLastMonth(), getDay(), getYear());
$sql = ''; $mode = '';

// Shall I sent activation or deactivation mail?
$sql = "SELECT `userid`, `email` FROM `{?_MYSQL_PREFIX?}_user_data` WHERE (`bonus_rallye_enable_notify` ";
switch (getConfig('bonus_active')) {
	case 'Y': // Active rallye is activated
		if (getConfig('bonus_enable_notify') == 'Y') {
			// Okay, let's check for member accounts
			$sql .= '= 0 OR (`bonus_rallye_enable_notify` > 0 AND `bonus_rallye_enable_notify` < `bonus_rallye_disable_notify`)';
			$mode = 'enable';
		} else {
			// Do not notify!
			$sql = '';
		}
		break;

	case 'N': // Active rallye is deactivated
		if (getConfig('bonus_disable_notify') == 'Y') {
			// Okay, let's check for member accounts
			$sql .= ' > 0 AND `bonus_rallye_disable_notify` < `bonus_rallye_enable_notify`';
			$mode = 'disable';
		} else {
			// Do not notify!
			$sql = '';
		}
		break;
} // END - switch

if (!empty($sql)) {
	// The SQL command needs to be finisched here (only confirmed accounts!)
	$sql .= ") AND `status`='CONFIRMED' ORDER BY `last_online` ASC";

	// Normal notification mails or bonus mails?
	$sentBonusMails = ((getConfig('bonus_notify_points') > 0) && ($mode == 'enable') && (isExtensionActive('bonus')));

	// Load message body for bonus mails
	$message = loadEmailTemplate('bonus_enable_notify_body', '', '{PER}userid{PER}');
	$receiver = ''; $userids = array();

	// Check for accounts to be notified
	$result_main = SQL_QUERY($sql, __FILE__, __LINE__);
	if (!SQL_HASZERONUMS($result_main)) {
		// Okay lets notify all users!
		while ($content = SQL_FETCHARRAY($result_main)) {
			// Update account
			SQL_QUERY_ESC("UPDATE
	`{?_MYSQL_PREFIX?}_user_data`
SET
	`bonus_rallye_%s_notify`=UNIX_TIMESTAMP()
WHERE
	`userid`=%s
LIMIT 1",
				array(
					$mode,
					$content['userid']
				), __FILE__, __LINE__);

			// Load email template and send it to the user!
			if ($sentBonusMails === true) {
				// Add userid to queue
				$userids[] = $content['userid'];
			} else {
				// Send normal notification mail to the members
				$message = loadEmailTemplate('bonus_' . $mode . '_notify', $content, $content['userid']);
				sendEmail($content['email'], '{--MEMBER_BONUS_RALLYE_' . strtoupper($mode) . '_SUBJECT--}', $message);
			}
		} // END - while

		// Shall I send out bonus mails?
		if ($sentBonusMails === true) {
			// Okay, make array to string
			$receiver = implode(';', $userids);

			// Prepare URL
			$url = 'modules.php?module=index&amp;what=login';

			// Insert mail
			addBonusMailToQueue('{--MEMBER_BONUS_RALLYE_' . strtoupper($mode) . '_SUBJECT--}', $message, $receiver, getConfig('bonus_notify_points'), getConfig('bonus_notify_wait'), $url, 0, 'normal', SQL_NUMROWS($result_main));
		} // END - if
	} // END - if

	// Free memory
	SQL_FREERESULT($result_main);
} // END - if

//
?>
